// ======================================================================
// 
// dllmem.cpp
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#include "first.h"
#include "dllmem.h"

#include <new.h>

// ======================================================================

u_int8 (*MemoryManager::getFreePattern)(void);
u_int8 (*MemoryManager::getUserPattern)(void);
u_int8 (*MemoryManager::getGuardPattern)(void);

void *(*DLLMemoryManager::alloc)(u_int sz, const char *filename, int line, bool array);
void  (*DLLMemoryManager::free)(void *ptr, bool array);

// ======================================================================

void *operator new(size_t size)
{
	FATAL(true, ("operator new without positional info (%d bytes)", size));
	return NULL; //lint !e527 // unreachable
}

// ----------------------------------------------------------------------

void *operator new(size_t size, const char *file, u_int16 line)
{
	return DLLMemoryManager::alloc(size, file, line, false);
}

// ----------------------------------------------------------------------

void operator  delete(void *ptr)
{
	if (ptr)
		DLLMemoryManager::free(ptr, false);
}

// ======================================================================

#if USE_NEW_ARRAY == 1

void *operator new[](size_t size)
{
	FATAL(true, ("operator new[] without positional info (%d bytes)", size));
	return NULL; //lint !e527 // unreachable
}

// ----------------------------------------------------------------------

void *operator new[](size_t size, const char *file, u_int16 line)
{
	return DLLMemoryManager::alloc(size, file, line, true);
}

// ----------------------------------------------------------------------

void operator  delete[](void *ptr)
{
	if (ptr)
		DLLMemoryManager::free(ptr, true);
}

#endif

// ======================================================================

